package trees;

import java.io.*;
import javax.swing.DefaultListModel;
import javax.swing.tree.*;

public class Window extends javax.swing.JFrame {

    /** Creates new form Window */
    public Window() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTree1 = new javax.swing.JTree();
        jButton1 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        jList1 = new javax.swing.JList();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTree1.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                jTree1ValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(jTree1);

        jButton1.setText("jButton1");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        jList1.setModel(new javax.swing.AbstractListModel() {
            String[] strings = { "Item 1", "Item 2", "Item 3", "Item 4", "Item 5" };
            public int getSize() { return strings.length; }
            public Object getElementAt(int i) { return strings[i]; }
        });
        jScrollPane2.setViewportView(jList1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 435, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(100, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private String fmt (long n)
    {
        String s = Long.toString (n);
        String t = "";
        int cnt = 0;
        for (int i = s.length()-1; i >= 0 ; i--)
        {
           t = s.charAt(i) + t;
           cnt ++;
           if (cnt % 3 == 0)
               t = " " + t;
        }
        return t;
    }

    DefaultTreeModel model;

    private void showDir
            (DefaultMutableTreeNode above,
             File dir)
    {
       File [] list = dir.listFiles();

       for (File f : list )
       {
          if (f.isDirectory())
          {
             DefaultMutableTreeNode node =
                new DefaultMutableTreeNode 
                     (new FileInfo (f));

             above.add (node);

             showDir (node, f);
          }
       }

    }

    private void showFiles (File dir)
    {
        DefaultListModel m = new DefaultListModel();
        jList1.setModel (m);

        for (File f : dir.listFiles())
            if (f.isFile())
               m.addElement(new FileInfo (f));
    }


    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
       // import javax.swing.tree.*;
       DefaultMutableTreeNode top =
          new DefaultMutableTreeNode ("Abc");

       model = new DefaultTreeModel (top);

       jTree1.setModel (model);

       /*
       for (int inx = 0; inx < list.length; inx++)
       {
           File f = list [inx];
       }
       */

       // import java.io.*;
       File dir = new File ("C:\\work");
       String t = dir.getAbsolutePath() + ", " +
                  fmt (dir.getUsableSpace()) + " of " +
                  fmt (dir.getTotalSpace());
       top.setUserObject (new FileInfo (dir));

       showDir (top, dir);
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jTree1ValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_jTree1ValueChanged
       TreePath path = evt.getPath();
       Object last = path.getLastPathComponent();
       if (last instanceof DefaultMutableTreeNode)
       {
         DefaultMutableTreeNode node =
                 (DefaultMutableTreeNode) last;
         Object obj = node.getUserObject ();
         if (obj instanceof FileInfo)
         {
            FileInfo fi = (FileInfo) obj;
            File f = fi.getFile();
            showFiles (f);
         }
       }
    }//GEN-LAST:event_jTree1ValueChanged

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Window().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JList jList1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JTree jTree1;
    // End of variables declaration//GEN-END:variables

}
